#include <gb/gb.h>
#include <gb/hardware.h>
#include <rand.h>

////////////////////////////////////////////////////////////////////////////////
// FUNCTION DECLARATIONS

UINT8 collisionCheck(UINT8, UINT8, UINT8, UINT8, UINT8, UINT8, UINT8, UINT8); 	// RECT TO RECT CHECK
void switchRomBanks(UINT8);
void fadeInBkg(UINT8);
void fadeOutBkg(UINT8 edelay);
void fadeInSprites(UINT8);
void fadeOutSprites(UINT8);
void playSFX();
void stopAllSounds();


void generatePassword();
void checkPassword();

extern void updateGame();

////////////////////////////////////////////////////////////////////////////////
// VARIABLE DECLARATIONS
UINT8 i,j,k;
UINT16 ii,jj,kk;


UINT8 musicposn = 0;
UINT8 musiccounter = 0;

UINT8 password[10], inpass[10];		//PASSWORD STORAGE VARIABLES

UINT8 usePassword;

UINT8 lastKeys;
UINT8 menuPosn;

UINT8 showPassword;

UINT8 playerX, playerY;

UINT8 heartPosnX[6];
UINT8 heartPosnY[6];
INT8 heartVelX[6];
INT8 heartVelY[6];

UINT8 hearts[6];						//CURRENCY WHEN REACH MAX - END GAME, BE SAD
UINT8 heartDisplay[6];

UINT8 bankInit = 0;						//ARE WE INITIALIZING A BANK CURRENTLY 0 = FALSE, 1 = TRUE
UINT8 subScreen = 0;

UINT8 kissPower;
UINT8 waifux;

UINT8 switchBankTo;
UINT8 level = 1;
UINT8 sublevel = 1;

UINT8 tempLine[20];

// BGM VARIABLES - START
UINT8 playBGMMusic;
UINT8 bgmSubPosn;
UINT8 bgmPosn;
UINT8 bgmLength;

UINT8 bgmChannelData1[320];
UINT8 bgmChannelData2[320];
UINT8 bgmChannelData4[320];

UINT8 frameTimer;
UINT8 eyes;
// SFX VARIABLES - START

UINT8 playSound;
UINT8 playSoundPosn;

UINT8 smallSFXFreq;
UINT8 bigSFXFreq;
UINT8 oldFreq;

UINT8 levelDisplay[5];

//CHANNEL[1] - START FREQUENCY[2] - DIRECTION [1] - SPEED[1] - TIMETOPLAY[1]
//DIRECTION 0x00 = -, Ox01 = +
const UINT8 sfxList[] = {0x00,
0x01,0x85,0x85,0x01,0x1f,0x10,		//PLAYSOUND = 1 - MENU NAVIGATION NOISE
0x01,0x86,0x85,0x01,0x04,0x20,		//PLAYSOUND = 7 - MENU ADVANCE NOISE
0x01,0x86,0x85,0x00,0x04,0x20,		//PLAYSOUND = 13 - MENU BACK NOISE
0x02,0x85,0x00,0x01,0x1f,0x04,		//PLAYSOUND = 19 - KISS NOISE 1
0x02,0x85,0x90,0x01,0x1f,0x04,		//PLAYSOUND = 25 - KISS NOISE 2
0x02,0x84,0x00,0x01,0x1f,0x04,		//PLAYSOUND = 31 - KISS NOISE 3
0x02,0x84,0x90,0x01,0x1f,0x04,		//PLAYSOUND = 37 - KISS NOISE 4
0x02,0x82,0x00,0x01,0x7f,0x10,		//PLAYSOUND = 43 - LEVEL COMPLETE
0x00
};


// MUSIC VARIABLES - END

//MAIN GAME LOOP - START
//BANK 0 - SET IN MEMORY - this will jst be functions

	int main(){
	showPassword = 0;
	usePassword= 0;
	levelDisplay[0] = 16;
	levelDisplay[1] = 18;
	levelDisplay[2] = 19;
	levelDisplay[3] = 17;
	levelDisplay[4] = 19;

	//INIT
	enable_interrupts();

	bgmPosn = 0;
	bgmSubPosn = 0;
	bgmLength = 240;

//	ENABLE_RAM_MBC1;


	DISPLAY_ON;
	initrand(DIV_REG);
	NR52_REG = 0x8F;	// TURN SOUND ON
	NR51_REG = 0xFF;	// sound channell SET TO 1
	NR50_REG = 0x77; 	// VOLUME MAX = 0x77, min = 0x00

	OBP0_REG=0x1B;		//SET SPRITE PALETTE UP

	playSound = 0;
	playSoundPosn = 0;

	switchRomBanks(1);


		while(1){

			if (playSound != 0){
			playSFX();
			}

			if (musiccounter == 32){
			musicposn+=3;
			musiccounter = 0;
			}

		musiccounter++;



		updateGame();
		frameTimer++;

			if (switchBankTo != 0){
			switchRomBanks(switchBankTo);
			switchBankTo = 0;
			}

		lastKeys = joypad();
		wait_vbl_done();
		}

	}


// COLLISION CHECKS
	UINT8 collisionCheck(UINT8 x1, UINT8 y1, UINT8 w1, UINT8 h1, UINT8 x2, UINT8 y2, UINT8 w2, UINT8 h2){

		if ((x1 < (x2+w2)) && ((x1+w1) > x2) && (y1 < (h2+y2)) && ((y1+h1) > y2)){
		return 1;
		} else {
		return 0;
		}

	}


//SWITCH ROM BANKS

	void switchRomBanks(UINT8 newBank){
	bankInit = 1;
	SWITCH_ROM_MBC1(newBank);
	}

// VARIABLE FADE IN BKG LAYER
	void fadeInBkg(UINT8 edelay){
	BGP_REG=0x00;
	delay(edelay);
	SHOW_BKG;
	BGP_REG=0x54;
	SHOW_BKG;
	delay(edelay);
	BGP_REG=0xA4;
	SHOW_BKG;
	delay(edelay);
	BGP_REG=0xE4;
	SHOW_BKG;
	}

// VARIABLE FADE OUT BKG LAYER
	void fadeOutBkg(UINT8 edelay){
	BGP_REG=0xE4;
	delay(edelay);
	SHOW_BKG;
	BGP_REG=0xA4;
	SHOW_BKG;
	delay(edelay);
	BGP_REG=0x54;
	SHOW_BKG;
	delay(edelay);
	BGP_REG=0x00;
	SHOW_BKG;
	}


// VARIABLE FADE IN SPRITES
	void fadeInSprites(UINT8 edelay){
	OBP0_REG=0x00;
	delay(edelay);
	SHOW_SPRITES;
	OBP0_REG=0x54;
	SHOW_SPRITES;
	delay(edelay);
	OBP0_REG=0xA4;
	SHOW_SPRITES;
	delay(edelay);
	OBP0_REG=0xE4;
	SHOW_SPRITES;
	}

// VARIABLE FADE OUT SPRITES
	void fadeOutSprites(UINT8 edelay){
	OBP0_REG=0xE4;
	delay(edelay);
	SHOW_SPRITES;
	OBP0_REG=0xA4;
	SHOW_SPRITES;
	delay(edelay);
	OBP0_REG=0x54;
	SHOW_SPRITES;
	delay(edelay);
	OBP0_REG=0x00;
	SHOW_SPRITES;
	}






//PLAY SOUND FX

	void playSFX(){
	NR50_REG = 0x77; //SFX SHOULD BE LOUD
		switch(playSoundPosn){
		//INIT VARIABLES
		case 0:
		playSoundPosn = 1;
		smallSFXFreq = sfxList[playSound+2];
		bigSFXFreq = sfxList[playSound+1];
		break;

		//SOUND LOOP
		default:
		oldFreq = smallSFXFreq;

			switch (sfxList[playSound+3]){
			//DECREASE FREQUENCY
			case 0:
			smallSFXFreq-= sfxList[playSound+4];

				if (oldFreq < smallSFXFreq){
				bigSFXFreq--;
				}

			break;

			//INCREASE FREQUENCY
			default:
			smallSFXFreq+= sfxList[playSound+4];

				if (oldFreq > smallSFXFreq){
				bigSFXFreq++;
				}

			break;
			}
/*
CHANNEL[1] - START FREQUENCY[2] - DIRECTION [1] - SPEED[1] - TIMETOPLAY[1]
0x01,0x80,0x00,0x01,0x01,0xFF		//SQUARE WAVE
	NR11_REG = sfxList[playSound]
	*/
			//UPDATE CHANNEL REGISTERS
			switch (sfxList[playSound]){
			case 1:
			NR11_REG = 0xC0;
			NR12_REG = 0x3F;

			NR13_REG = smallSFXFreq;
			NR14_REG = bigSFXFreq;
			break;

			case 2:
			NR21_REG = 0xC0;
			NR22_REG = 0x3F;

			NR23_REG = smallSFXFreq;
			NR24_REG = bigSFXFreq;
			break;

			case 4:
			NR41_REG = 0x7F;
			NR42_REG = 0x7F;

			NR43_REG = smallSFXFreq;
			NR44_REG = bigSFXFreq;
			break;
			}

		playSoundPosn++;
//TERMINATE PLAYING THE SOUND
			if (playSoundPosn == sfxList[playSound+5]){
			playSoundPosn = 0;
			stopAllSounds();
			playSound = 0;
			}

		break;
		}
	}



//STOP ALL SOUNDS

	void stopAllSounds(){

	NR11_REG = 0x00;
	NR12_REG = 0x00;
	NR13_REG = 0x00;
	NR14_REG = 0x00;

	NR21_REG = 0x00;
	NR22_REG = 0x00;
	NR23_REG = 0x00;
	NR24_REG = 0x00;

	NR41_REG = 0x00;
	NR42_REG = 0x00;
	NR43_REG = 0x00;
	NR44_REG = 0x00;
	}

// GENERATE SIMPLE PASSWORD
	void generatePassword(){
	i=0;
	i+=hearts[5];
	i+=hearts[4];
	i+=hearts[3];
	i+=hearts[2];
	i+=hearts[i];
	i+=hearts[0];
	i+=(level/10);
	i+=(level % 10);
	i+=sublevel;

	i = i % 10;

	password[0] = hearts[5];
	password[1] = hearts[0];
	password[2] = hearts[3];
	password[3] = hearts[1];
	password[4] = hearts[2];
	password[5] = hearts[4];
	password[7] = level/10;
	password[8] = level % 10;
	password[6] = sublevel;
	password[9] = i;


	for ( i=0; i!=10; i++){

		if (password[i] <5){
		password[i]+=32;
		} else {
		password[i]+=111;
		}
	}


	}

// CHECK SIMPLE PASSWORD
	void checkPassword(){
	i=0;
	i+= password[0];
	i+=password[1];
	i+=password[2];
	i+=password[3];
	i+=password[4];
	i+=password[5];
	i+=password[6];
	i+=password[7];
	i+=password[8];


	//	if (password[9] == (i%10)){
		//VALID PASSWORD
		level = (password[7]*10)+password[8];
		sublevel = password[6];
		hearts[5] = password[0];
		hearts[4] = password[5];
		hearts[3] = password[2];
		hearts[2] = password[4];
		hearts[1] = password[3];
		hearts[0] = password[1];
		playSound= 43;
		playSoundPosn = 0;
		usePassword= 1;
		fadeOutBkg(64);
		switchBankTo = 3;
	//	} else {
		//INVALID PASSWORD - SAD NOISE
	//	playSound= 13;
	//	playSoundPosn = 0;


//		}

	}